Package com.enonic.xp.admin.widget

## Class WidgetDescriptor.Builder

- java.lang.Object
- - com.enonic.xp.admin.widget.WidgetDescriptor.Builder

- Enclosing class:
    WidgetDescriptor

      public static class WidgetDescriptor.Builder
      extends Object

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `Map<String,​String>` | `config` |
    `Set<String>` | `interfaces` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `WidgetDescriptor.Builder` | `addInterface​(String interfaceName)` |
    `WidgetDescriptor.Builder` | `addProperty​(String key, String value)` |
    `WidgetDescriptor` | `build()` |
    `WidgetDescriptor.Builder` | `description​(String description)` |
    `WidgetDescriptor.Builder` | `descriptionI18nKey​(String descriptionI18nKey)` |
    `WidgetDescriptor.Builder` | `displayName​(String displayName)` |
    `WidgetDescriptor.Builder` | `displayNameI18nKey​(String displayNameI18nKey)` |
    `WidgetDescriptor.Builder` | `key​(DescriptorKey key)` |
    `WidgetDescriptor.Builder` | `setAllowedPrincipals​(Collection<PrincipalKey> allowedPrincipals)` |
    `WidgetDescriptor.Builder` | `setIcon​(Icon icon)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### interfaces

          public final Set<String> interfaces

    - #### config

          public final Map<String,​String> config

  - ### Method Detail

    - #### key

          public WidgetDescriptor.Builder key​(DescriptorKey key)

    - #### displayName

          public WidgetDescriptor.Builder displayName​(String displayName)

    - #### displayNameI18nKey

          public WidgetDescriptor.Builder displayNameI18nKey​(String displayNameI18nKey)

    - #### description

          public WidgetDescriptor.Builder description​(String description)

    - #### descriptionI18nKey

          public WidgetDescriptor.Builder descriptionI18nKey​(String descriptionI18nKey)

    - #### setIcon

          public WidgetDescriptor.Builder setIcon​(Icon icon)

    - #### addInterface

          public WidgetDescriptor.Builder addInterface​(String interfaceName)

    - #### setAllowedPrincipals

          public WidgetDescriptor.Builder setAllowedPrincipals​(Collection<PrincipalKey> allowedPrincipals)

    - #### addProperty

          public WidgetDescriptor.Builder addProperty​(String key,
                                                      String value)

    - #### build

          public WidgetDescriptor build()